#Matt666
#Converts components to groups
def c2g
	@model = Sketchup.active_model
	sel = @model.selection
	@model.start_operation "Convert components to groups"
	@nb = 0
	ents = @model.active_entities
	var = c2g_nbcomp
	cd=Sketchup.active_model.definitions.count
	if sel.empty?
		while var == true 
			c2g_boucle(ents)
			var = c2g_nbcomp
		end
		UI.messagebox(@nb.to_s + " component(s) converted.")
		puts @nb.to_s + " component(s) converted."
		c2g_purger if UI.messagebox("Nettoyer les composants inutilses ?", MB_YESNO, "Components to groups")==6
	else
		c2g_boucle(sel)
		UI.messagebox(@nb.to_s + " Composants convertits.")
		puts @nb.to_s + " Composants convertits."
		c2g_purger if UI.messagebox("Effacer les composants inutilises  ?", MB_YESNO, "Components to groups")==6
	end
	@model.commit_operation
end

def c2g_boucle(ss)
	ss.each do |ent|
		case ent.typename
			when 'Group'
			c2g_boucle(ent.entities)
			
			when 'ComponentInstance'
			grp = nil
			sel = []
			grp = @model.active_entities.add_group sel.push(ent)
			grp.name = ent.definition.name
			ent.explode
			sel.clear.push(grp)
			@nb +=1
			c2g_boucle(sel)
		end
	end
end

def c2g_purger
	model=Sketchup.active_model
	cd=model.definitions.count
	model.definitions.purge_unused
	cd=cd-model.definitions.count
	UI.messagebox("Composants nettoyes: "+cd.to_s+" elements.")
	puts "Purged components: "+cd.to_s+" elements."
end

def c2g_nbcomp
	@model.active_entities.each {|ent|return true if ent.typename == 'ComponentInstance'}
	return false
end

def c2g_validate
	Sketchup.active_model.selection.each {|e| return true if e.class == Sketchup::ComponentInstance}
	return nil
end

if( not file_loaded?("C2G.rb") )
	
	cmd = UI::Command.new("Composants en groupe")  { c2g }
	cmd.tooltip = "Transforme les composants en groupe"
    cmd.menu_text = "Composants en groupe"
    cmd.small_icon = "AdebeoIcon/C-Gpt.png"
    cmd.large_icon = "AdebeoIcon/C-Ggd.png"
    UI.menu("Plugins").add_item cmd
    toolbar = UI::Toolbar.new "Adebeo_ensemble"
    toolbar = toolbar.add_item cmd
	file_loaded("C2G.rb")
end
